/**
 * Created with IntelliJ IDEA.
 * User: abx
 * Date: 28/04/13
 * Time: 9:01 PM
 * To change this template use File | Settings | File Templates.
 */

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Orientation;
import javafx.geometry.Pos;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Control;
import javafx.scene.control.Label;
import javafx.scene.layout.TilePane;
import javafx.scene.layout.TilePaneBuilder;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.scene.text.TextAlignment;
import javafx.stage.Stage;

public class JavaFXCounter extends Application {

    Counter counter;

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) {

        double width = primaryStage.getWidth();
        double height = primaryStage.getHeight();

        final double maxWidth = 120f;
        final double maxHeight = 120f;

        counter = new Counter();

        Button incrementButton = new Button("Increment");
        incrementButton.setMaxSize(maxWidth, maxHeight);
        incrementButton.setStyle("-fx-font-size: 16pt;");
        //incrementButton.setPrefHeight(30);
        Button resetButton = new Button("Reset");
        resetButton.setMaxSize(maxWidth, maxHeight);
        resetButton.setStyle("-fx-font-size: 16pt;");

        final Label label = new Label();
        label.alignmentProperty().setValue(Pos.BASELINE_CENTER);
        label.setFont(Font.font("Arial", FontWeight.BOLD, 24));
        label.setText(String.format("%d%n", counter.getCount()));
        label.setMinSize(150,Control.USE_COMPUTED_SIZE);
        label.setMaxSize(150,Control.USE_COMPUTED_SIZE);

        TilePane tilePanes = TilePaneBuilder.create()
                .orientation(Orientation.VERTICAL)
                .alignment(Pos.BASELINE_CENTER)
                .prefTileHeight(Control.USE_COMPUTED_SIZE)
                .prefTileWidth(Control.USE_COMPUTED_SIZE)
                .vgap(5)
                .hgap(0)
                .padding(new Insets(0, 1, 1, 0))
                .children(label, incrementButton, resetButton)
                .build();


        incrementButton.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent actionEvent) {
                counter.increment();
                label.setText(String.format("%d", counter.getCount()));

            }
        });

        resetButton.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent actionEvent) {
                counter.reset();
                label.setText(String.format("%d", counter.getCount()));
            }
        });

        primaryStage.setTitle("JavaFX Counter");
        Group root = new Group();
        Scene scene = new Scene(root, Color.WHITE);


        root.getChildren().add(tilePanes);
        primaryStage.setScene(scene);
/*
        primaryStage.setMaxHeight(Control.USE_COMPUTED_SIZE);
        primaryStage.setMaxWidth(Control.USE_COMPUTED_SIZE);
*/
        primaryStage.show();

    }
}
